﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Pages;
using Application;
using Business;
using UserControls;
using Framework;

namespace PageLayout
{
    public partial class NewsPageLayout : ContextPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                SelectMenuItem(UserControls.Menu.Menu.ElementsMenu.NewsPageLayout);
                DisplayAllParagraphs();
            }
        }

        private void DisplayAllParagraphs()
        {
            if(!string.IsNullOrEmpty(Request.QueryString["id"]))
            {
                string currentId = MappingTool.CatchNull(Request.QueryString["id"]);
                VONews news = BusinessNews.GetNewsById(currentId);
                titleSpot.Content = news.Title;
                descriptionSpot.Content = news.Description;
            }
            rpterParagraph.DataSource = BusinessParagraph.GetAllParagraphs();
            rpterParagraph.DataBind();
        }
    }
}