﻿<%@ WebHandler Language="C#" Class="Handler" %>
using System;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Collections.Generic;
using System.Web.SessionState;
using Business;
using Application;
using MySqlConnection;
using Framework;

public class Handler : IHttpHandler, IReadOnlySessionState
{

    public void ProcessRequest(HttpContext context)
    {
        string picture_id = string.Empty;
        try
        {
            picture_id = MappingTool.CatchNull(context.Request.QueryString["picture_id"]);
        }
        catch
        {
        }

        VOImage img = new VOImage();
        if (context.Session[SessionConstants.SessionListImages] != null)
        {
            List<VOImage> allImages = context.Session[SessionConstants.SessionListImages] as List<VOImage>;
            img = (from imgSelected in allImages.ToList()
                   where imgSelected.Id == picture_id
                   select imgSelected).FirstOrDefault();
        }
        else
        {
            img = BusinessImage.GetImageById(picture_id);
        }
        //List<VOImage> allImages = context.Session[SessionConstants.SessionListImages] as List<VOImage>;
        //VOImage img = (from imgSelected in allImages.ToList()
        //                  where imgSelected.Id == picture_id
        //                  select imgSelected).FirstOrDefault();
        if (img != null)
        {
            context.Response.OutputStream.Write(img.Data, 0, img.Size);
        }
    }
    public bool IsReusable
    {
        get
        {
            return false;
        }
    }
}