using System;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Security;
using CreditAgricole.Framework;

namespace CreditAgricole.PageLayout.Features.CreditAgricoleContentTypePage
{
    /// <summary>
    /// This class handles events raised during feature activation, deactivation, installation, uninstallation, and upgrade.
    /// </summary>
    /// <remarks>
    /// The GUID attached to this class may be used during packaging and should not be modified.
    /// </remarks>

    [Guid("c5e85e23-cd39-42fb-9632-8690f372b662")]
    public class CreditAgricoleContentTypePageEventReceiver : SPFeatureReceiver
    {
        // Uncomment the method below to handle the event raised after a feature has been activated.

        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            SPSite site = properties.Feature.Parent as SPSite;
            SPContentType ctPageLayout = site.RootWeb.ContentTypes[Constants.ITBasePageContentType];
            if (ctPageLayout != null)
            {
                SPField linkField1 = site.RootWeb.Fields["Lien 1"];
                SPField linkField2 = site.RootWeb.Fields["Lien 2"];
                SPField linkField3 = site.RootWeb.Fields["Lien 3"];
                SPField linkField4 = site.RootWeb.Fields["Lien 4"];
                if (linkField1 != null)
                {
                    if (!ctPageLayout.Fields.ContainsField(linkField1.Title))
                    {
                        ctPageLayout.Fields.Add(linkField1);
                        ctPageLayout.Update(true);
                    }
                }

            }
        }


        // Uncomment the method below to handle the event raised before a feature is deactivated.

        //public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        //{
        //}


        // Uncomment the method below to handle the event raised after a feature has been installed.

        //public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        //{
        //}


        // Uncomment the method below to handle the event raised before a feature is uninstalled.

        //public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        //{
        //}

        // Uncomment the method below to handle the event raised when a feature is upgrading.

        //public override void FeatureUpgrading(SPFeatureReceiverProperties properties, string upgradeActionName, System.Collections.Generic.IDictionary<string, string> parameters)
        //{
        //}
    }
}
